// $Author: jmartin $
// $Date: 2000/08/16 21:55:56 $
// $Source: /home/rigi/proj/cvs/Rigi/cobparse/cobinit.C,v $
// $Locker:  $
// $State: Exp $
//
// ------------------------------------------------------------------------

#include <string.h>
#include "cobparse.h"
#include "cobinit.h"

/*
	MJW 940109
	added NOT END-PERFORM ALLOWING ZEROES CONSOLE
	SPACES ZEROS LOW-VALUES HIGH-VALUES END-IF
	I have changed the keyword lookup to simple binary search.
	Therefore, the keywords must be listed in alphabetical order!!

	MJW 950901
	introduced the "bonus" keyword list
	END-IF END-EVALUATE END-PERFORM INITIALIZE
	DESCRIPTOR EVALUATE OTHER REFERENCE
*/

static int size;		// number of keywords
static int bsize;		// number of bonus keywords

// Alphabetical order is imperative!

struct Keyword {
  char	*name;
  int	token;
};

static struct Keyword Keywords [] = {
  "ACCEPT",	TACCEPT,
  "ACCESS",	TACCESS,
  "ADD",	TADD,
  "ADVANCING",	TADVANCING,
  "AFTER",	TAFTER,
  "ALL",	TALL,
  "ALPHABETIC",	TALPHABETIC,
  "ALSO",	TALSO,
  "ALTERNATE",	TALTERNATE,
  "AND",	TAND,
  "ARE",	TARE,
  "AREA",	TAREA,
  "ASCENDING",	TASCENDING,
  "ASSIGN",	TASSIGN,
  "AT",		TAT,
  "AUTHOR",	TAUTHOR,
  "AUTO",	TAUTO,
  "BACKWARD",	TBACKWARD,
  "BEFORE",	TBEFORE,
  "BELL",	TBELL,
  "BLANK",	TBLANK,
  "BLINK",	TBLINK,
  "BLOCK",	TBLOCK,
  "BOTTOM",	TBOTTOM,
  "BY",		TBY,
  "CALL",	TCALL,
  "CANCEL",	TCANCEL,
  "CHAIN",	TCHAIN,
  "CHARACTER",	TCHARACTER,
  "CHARACTERS",	TCHARACTERS,
  "CLOSE",	TCLOSE,
  "CODE",	TCODE,
  "CODE-SET",	TCODE_SET,
  "COL",	TCOL,
  "COLLATING",	TCOLLATING,
  "COMMA",	TCOMMA,
  "COMP",	TCOMP,
  "COMPUTE",	TCOMPUTE,
  "CONFIGURATION",TCONFIG,
  "CONSOLE",	TCONSOLE,
  "CONTAINS",	TCONTAINS,
  "COPY",	TCOPY,
  "CORR",	TCORR,
  "CORRESPONDING",TCORRESPONDING,
  "CURRENCY",	TCURRENCY,
  "DATA",	TDATA,
  "DATE",	TDATE,
  "DATE-COMPILED",TDATE_COMP,
  "DATE-WRITTEN",TDATE_WRIT,
  "DAY",	TDAY,
  "DECIMAL-POINT",TDEC_POINT,
  "DECLARATIVES",TDECLARATIVES,
  "DELETE",	TDELETE,
  "DELIMITED",	TDELIMITED,
  "DEPENDING",	TDEPENDING,
  "DESCENDING",	TDESCENDING,
  "DICTIONARY",	TDICTIONARY,
  "DISK",	TDISK,
  "DISPLAY",	TDISPLAY,
  "DIVIDE",	TDIVIDE,
  "DIVISION",	TDIVISION,
  "DOWN",	TDOWN,
  "DUPLICATES",	TDUPLICATES,
  "DYNAMIC",	TDYNAMIC,
  "ELSE",	TELSE,
  "END",	TEND,
  "END-OF-PAGE",TEND_OF_PAGE,
  "ENVIRONMENT",TENVIRON,
  "EOP",	TEOP,
  "EQUAL",	TEQUAL,
  "ERROR",	TERROR,
  "ESCAPE",	TESCAPE,
  "EXCEPTION",	TEXCEPTION,
  "EXCLUSIVE",	TEXCLUSIVE,
  "EXIT",	TEXIT,
  "EXTEND",	TEXTEND,
  "FD",		TFD,
  "FILE",	TFILE,
  "FILE-CONTROL",TFILE_CONTROL,
  "FILLER",	TFILLER,
  "FIRST",	TFIRST,
  "FIXED",	TFIXED,
  "FOOTING",	TFOOTING,
  "FOR",	TFOR,
  "FROM",	TFROM,
  "FULL",	TFULL,
  "GIVING",	TGIVING,
  "GO",		TGO,
  "GREATER",	TGREATER,
  "HIGH-VALUE",	THIGH_VALUE,
  "HIGH-VALUES",THIGH_VALUES,
  "I-O",	TI_O,
  "I-O-CONTROL",TI_O_CONTROL,
  "IDENTIFICATION",TIDENT, 
  "IF",		TIF,
  "IMMEDIATE",	TIMMEDIATE,
  "IN",		TIN,
  "INDEX",	TINDEX, 
  "INDEXED",	TINDEXED,
  "INITIAL",	TINITIAL,
  "INPUT",	TINPUT, 
  "INPUT-OUTPUT",TINPUT_OUTPUT,
  "INSPECT",	TINSPECT,
  "INSTALLATION",TINSTALLATION, 
  "INTO",	TINTO,
  "INVALID",	TINVALID,
  "IS",		TIS,
  "JUST",	TJUST,
  "KEY",	TKEY,
  "KEYBOARD",	TKEYBOARD,
  "LABEL",	TLABEL,
  "LEADING",	TLEADING,
  "LEFT",	TLEFT,
  "LESS",	TLESS,
  "LINAGE",	TLINAGE,
  "LINAGE-COUNTER",TLINAGE_COUNTER,
  "LINE",	TLINE,
  "LINES",	TLINES,
  "LINKAGE",	TLINKAGE,
  "LOCK",	TLOCK,
  "LOW-VALUE",	TLOW_VALUE,
  "LOW-VALUES",	TLOW_VALUES,
  "MEMORY",	TMEMORY,
  "MERGE",	TMERGE,
  "MODE",	TMODE,
  "MODULES",	TMODULES,
  "MOVE",	TMOVE,
  "MULTIPLE",	TMULTIPLE,
  "MULTIPLY",	TMULT,
  "NAME",	TNAME,
  "NATIVE",	TNATIVE,
  "NEGATIVE",	TNEGATIVE,
  "NEXT",	TNEXT,
  "NO",		TNO,
  "NOT",	TNOT,
  "NUMBER",	TNUMBER,  
  "NUMERIC",	TNUMERIC,
  "OBJECT-COMPUTER",TOBJECT_COMP,
  "OCCURS",	TOCCURS, 
  "OF",		TOF,
  "OFF",	TOFF,
  "OMITTED",	TOMITTED,
  "ON",		TON,
  "OPEN",	TOPEN,
  "OPTIONAL",	TOPTIONAL,
  "OR",		TOR,
  "ORGANIZATION",TORGANIZATION,
  "OUTPUT",	TOUTPUT,  
  "OVERFLOW",	TOVERFLOW,
  "PAGE",	TPAGE,
  "PERFORM",	TPERFORM,
  "PIC",	TPIC,
  "PLUS",	TPLUS,
  "POINTER",	TPOINTER,
  "POSITION",	TPOSITION,
  "POSITIVE",	TPOSITIVE,
  "PREVIOUS",	TPREVIOUS,
  "PRINTER",	TPRINTER,
  "PROCEDURE",	TPROCEDURE,
  "PROGRAM",	TPROGRAM,
  "PROGRAM-ID",	TPROG_ID,
  "QUOTE",	TQUOTE,
  "RANDOM",	TRANDOM,
  "READ",	TREAD,
  "RECORD",	TRECORD,
  "RECORDING",	TRECORDING,
  "RECORDS",	TRECORDS,
  "REDEFINES",	TREDEFINES,
  "RELATIVE",	TRELATIVE,
  "RELEASE",	TRELEASE,
  "REMAINDER",	TREMAINDER,
  "RENAMES",	TRENAMES,
  "REPLACING",	TREPLACING,
  "REQUIRED",	TREQUIRED,
  "RERUN",	TRERUN,
  "RETURN",	TRETURN,
  "REWIND",	TREWIND,
  "REWRITE",	TREWRITE,
  "RIGHT",	TRIGHT,
  "ROUNDED",	TROUNDED,
  "RUN",	TRUN,
  "SAME",	TSAME,
  "SCREEN",	TSCREEN,
  "SD",		TSD,
  "SEARCH",	TSEARCH,
  "SECTION",	TSECTION,
  "SECURE",	TSECURE,
  "SECURITY",	TSECURITY,
  "SEGMENT-LIMIT",TSEGMENT_LIMIT,
  "SELECT",	TSELECT,
  "SENTENCE",	TSENTENCE,
  "SEPARATE",	TSEPARATE,
  "SEQUENCE",	TSEQUENCE,
  "SEQUENTIAL",	TSEQUENTIAL,
  "SET",	TSET,
  "SIGN",	TSIGN,
  "SIZE",	TSIZE,
  "SORT",	TSORT,
  "SORT-MERGE",	TSORT_MERGE,
  "SOURCE-COMPUTER",TSOURCE_COMP,
  "SPACE",	TSPACE,
  "SPACES",	TSPACES,
  "SPECIAL-NAMES",TSPECIAL_NAMES,
  "STANDARD",	TSTANDARD,
  "START",	TSTART,
  "STATUS",	TSTATUS,
  "STOP",	TSTOP,
  "SUBTRACT",	TSUBT,
  "SWITCH",	TSWITCH,
  "SYMBOLIC",	TSYMBOLIC,
  "SYNC",	TSYNC,
  "TALLYING",	TTALLYING,
  "THAN",	TTHAN,
  "THROUGH",	TTHROUGH,
  "THRU",	TTHRU,
  "TIME",	TTIME,
  "TIMES",	TTIMES,
  "TO",		TTO,
  "TRAILING",	TTRAILING,
  "UNDELETE",	TUNDELETE,
  "UNLOCK",	TUNLOCK,
  "UNSTRING",	TUNSTRING,
  "UNTIL",	TUNTIL,
  "UP",		TUP,
  "UPON",	TUPON,
  "USAGE",	TUSAGE,
  "USE",	TUSE,
  "USER",	TUSER,
  "USING",	TUSING,
  "VALUE",	TVALUE,
  "VALUES",	TVALUES,
  "VARIABLE",	TVARIABLE,
  "VARYING",	TVARYING,
  "WHEN",	TWHEN,
  "WITH",	TWITH,
  "WORDS",	TWORDS,
  "WORKING-STORAGE",TWSTOR,
  "WRITE",	TWRITE,
  "ZERO",	TZERO,
  "ZEROES",	TZEROES,
  "ZEROS",	TZEROS,
};

static struct Keyword Bonuswords[] = {
  "ALLOWING",	TALLOWING,
  "ALPHANUMERIC",TALPHANUMERIC,
  "CONTINUE",	TCONTINUE,
  "DESCRIPTOR",	TDESCRIPTOR,
  "END-DIVIDE", TEND_DIVIDE,
  "END-EVALUATE",TEND_EVALUATE,
  "END-IF",	TEND_IF,
  "END-PERFORM",TEND_PERFORM,
  "END-READ",   TEND_READ,
  "END-RETURN", TEND_RETURN,
  "END-SEARCH", TEND_SEARCH,
  "END-START",  TEND_START,
  "END-STRING", TEND_STRING,
  "END-WRITE",  TEND_WRITE,
  "EVALUATE",	TEVALUATE,
  "FAILURE",	TFAILURE,
  "FUNCTION",   TFUNCTION,
  "INITIALIZE",	TINITIALIZE,
  "ORDER",      TORDER,
  "OTHER",	TOTHER,
  "REFERENCE",	TREFERENCE,
  "RETURN-CODE",TRETURN_CODE,
  "STRING",     TSTRING,
  "TEST",       TTEST,
  "TRUE",	TTRUE,
};

static int find_sym( char* name, Keyword *table, int size )
{
  register struct Keyword *r;
  register int low=0; register int high=size-1;
  register int s,mid;
  do {
    mid = (low+high)>>1;
    r = table + mid;
    s = strcmp(name,r->name);
    if (s==0) 
      return r->token;
    else 
      if (s>0) 
	low = mid+1;
      else 
	high = mid-1;
  } while (low<=high);
  return TID;
}

// EXPORT

void compiler_init()
{
  size = sizeof(Keywords)/sizeof(Keyword);
  bsize = sizeof(Bonuswords)/sizeof(Keyword);
}

int findsym( char *name, int extended )
{
  int token;
  token = find_sym( name, Keywords, size );
  if (extended) 
    if (token==TID)
      token = find_sym( name, Bonuswords, bsize );
  return token;
}

// ------------------------------------------------------------------------
//
// $Log: cobinit.C,v $
// Revision 1.4  2000/08/16 21:55:56  jmartin
// lots of more improvements (more language features supported)
//
// Revision 1.3  2000/08/15 06:41:27  jmartin
// major overhaul & extensions
//
// Revision 1.2  2000/08/13 02:27:25  jmartin
// check-in of mwhitney's changes of September 1995
//
//   Revision 1.1  1994/04/27  22:18:45  mwhitney
//   Initial revision
//
//
